﻿using UnityEngine;
using HarmonyLib;
using System.Collections.Generic;
using System;
using System.Reflection;

public class DissociationDissimulation : Mod
{
    public static Dictionary<Network_Player, int> playerValues;
    public static List<Tuple<Type, int, int>> heads = new List<Tuple<Type, int, int>> {
        new Tuple<Type, int, int>(typeof(AI_StateMachine_Shark),127,-1),
        new Tuple<Type, int, int>(typeof(AI_StateMachine_PufferFish),206,-1),
        new Tuple<Type, int, int>(typeof(AI_StateMachine_Boar),253,-1),
        new Tuple<Type, int, int>(typeof(AI_StateMachine_MamaBear),287,-1),
        new Tuple<Type, int, int>(typeof(AI_StateMachine_Bear),285,287),
        new Tuple<Type, int, int>(typeof(AI_StateMachine_StoneBird),205,306)
    };
    Harmony harmony;
    public void Start()
    {
        playerValues = new Dictionary<Network_Player, int>();
        harmony = new Harmony("com.aidanamite.DissociationDissimulation");
        harmony.PatchAll();
        Log("Mod has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);
        Log("Mod has been unloaded!");
    }
}

static class ExtentionMethods
{
    public static bool IsWearing(this Network_Player player, int itemIndex, int itemIndex2)
    {
        Equipment[] equips = Traverse.Create(player.PlayerEquipment).Field("equipment").GetValue<Equipment[]>();
        for (int i = 0; i < equips.Length; i++)
            if (equips[i].equipableItem.UniqueIndex == itemIndex || equips[i].equipableItem.UniqueIndex == itemIndex2)
                return equips[i].Equipped;
        return false;
    }
}

[HarmonyPatch(typeof(AI_StateMachine), "UpdateStateMachine")]
public class Patch_ValidWaterTarget
{
    static void Prefix(AI_StateMachine __instance, ref List<Player> __state)
    {
        __state = new List<Player>();
        foreach (Network_Player player in ComponentManager<Semih_Network>.Value.remoteUsers.Values)
            if (!player.PlayerScript.IsDead)
                foreach (Tuple<Type, int, int> connection in DissociationDissimulation.heads)
                    if (connection.Item1.IsInstanceOfType(__instance))
                    {
                        if (player.IsWearing(connection.Item2, connection.Item3))
                        {
                            player.PlayerScript.IsDead = true;
                            __state.Add(player.PlayerScript);
                        }
                        break;
                    }
    }
    static void Postfix(ref List<Player> __state)
    {
        foreach (Player player in __state)
            player.IsDead = false;
    }
}